/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.ple.web.ui.query.QueryRow");

dojo.require('dijit._Templated');
dojo.require('com.ibm.relm.common.web.ui.util');
dojo.require('com.ibm.relm.common.web.ui.table.HoverRow');

(function(){
	var CHECKED_OUT_IMAGE = dojo.moduleUrl("com.ibm.relm.ple.web", "ui/images/asset-working.gif").uri;
	var CHECKED_IN_IMAGE = dojo.moduleUrl("com.ibm.relm.ple.web", "ui/images/asset.gif").uri;

	var util = com.ibm.relm.common.web.ui.util;



	dojo.declare(
		"com.ibm.relm.ple.web.ui.query.QueryRow",
		[ com.ibm.relm.common.web.ui.table.HoverRow ], 
		{
			EXTRA_COLUMNS: ['_branch_name', '_snapshot'],

			constructor: function(args, node) 
			{
				this._product = args.product;
			},

			initToolbar: function() {
				this.toolbar.addButton(this, null, {
					imgSrc: dojo.moduleUrl("com.ibm.relm.ple.web", "ui/images/history-enabled.gif").uri,
					label: 'Verlauf'
				});
				this.toolbar.addButton(this, null, {
					imgSrc: dojo.moduleUrl("com.ibm.relm.ple.web", "ui/images/search-icon-enabled.gif").uri,
					label: 'Verwendung suchen'
				});
			},

			postCreate: function() {
				this.inherited(arguments);

				var nameCell = this.addCell();
				dojo.addClass(nameCell, 'ple-HoverRow-nowrap');
				var icon = dojo.create('img', {
					src: this._product.state == 'checked_out' ? CHECKED_OUT_IMAGE : CHECKED_IN_IMAGE,
					alt: 'Product Image',
					className: 'ple-HoverRow-resource-icon'
				}); 

				var link = dojo.create('a', {
					href: '#GO_TO_TREE'
				});

				link.appendChild(icon);
				link.appendChild(document.createTextNode(this._product.name));
				nameCell.appendChild(link);

				for (var i = 0; i < this.EXTRA_COLUMNS.length; i++) {
					var property = this.EXTRA_COLUMNS[i];

					var cell = this.addCell();
					dojo.addClass(cell, 'ple-HoverRow-nowrap');
					var value = this._product[property];
					if (value) {
						util.setText(cell, value);
					}	
				}

				this.initToolbar();

				// just freeing memory. May need to keep this around for actions later... we'll see
				delete this._product;
			},

			uninitialize: function() {
				this.inherited(arguments);
			}
		}	
	);

})();
